 -- First create these two tables 

CREATE TABLE testnulls (ID INT)
INSERT INTO testnulls VALUES (1)
INSERT INTO testnulls VALUES (2)
INSERT INTO testnulls VALUES (null)
 
CREATE TABLE testjoin (ID INT)
INSERT INTO testjoin VALUES (1)
INSERT INTO testjoin VALUES (3)

-- NOT IN

SELECT * FROM testjoin WHERE ID NOT IN(SELECT ID FROM testnulls)

SELECT * FROM testjoin WHERE ID NOT IN(SELECT ID FROM testnulls WHERE ID IS NOT NULL)

-- NOT EXISTS

SELECT *
FROM testjoin j
WHERE NOT EXISTS (
   SELECT 1
   FROM testnulls n
   WHERE n.ID = j.ID
)

-- LEFT and RIGHT JOIN
SELECT j.*
FROM
   testjoin j
   LEFT JOIN testnulls n ON n.ID = j.ID
WHERE n.ID IS NULL
 
SELECT j.*
   FROM  testnulls n
   RIGHT OUTER JOIN testjoin j ON n.ID = j.ID
   WHERE n.ID IS NULL

-- OUTER APPLY (SQL 2005 +)
SELECT j.*
   FROM testjoin j
   OUTER APPLY (
      SELECT id
      FROM testnulls n
      WHERE n.ID = j.ID
   ) a
WHERE a.ID IS NULL

-- EXCEPT(SQL 2005 +)
SELECT * FROM testjoin
EXCEPT
SELECT * FROM testnulls

SELECT * FROM testjoin
INTERSECT
SELECT * FROM testnulls

DECLARE @TABLE1 TABLE (id int IDENTITY(1,1), name varchar(10))
DECLARE @TABLE2 TABLE (id int IDENTITY(1,1), name varchar(10))
 
INSERT @TABLE1 VALUES ('DAVE')
INSERT @TABLE1 VALUES ('MARK')
 
INSERT @TABLE2 VALUES ('DAVE')
INSERT @TABLE2 VALUES (NULL)
 
SELECT * FROM @TABLE1 t1 WHERE NOT EXISTS (SELECT 1 FROM @TABLE2 t2 WHERE t1.NAME = t2.NAME)
 
SELECT * FROM @TABLE1
EXCEPT
SELECT * FROM @TABLE2

 
CREATE TABLE #TABLE1  (id int IDENTITY(1,1), name varchar(10))
CREATE TABLE #TABLE2  (id int IDENTITY(1,1), name varchar(10))
 
INSERT #TABLE1 VALUES ('DAVE')
INSERT #TABLE1 VALUES ('MARK')
 
INSERT #TABLE2 VALUES ('DAVE')
INSERT #TABLE2 VALUES (NULL)

SELECT * FROM #TABLE1
UNION
SELECT * FROM #TABLE2
 
 
SELECT * FROM #TABLE1
UNION ALL
SELECT * FROM #TABLE2


-- Timings of different techniques for finding missing records 
-- Here is the code for testing

CREATE TABLE     #TableA
                 (
                          i INT PRIMARY KEY CLUSTERED
                 )
 
INSERT   #TableA
SELECT   Number
FROM     dbo.F_TABLE_NUMBER_RANGE(0, 999999)
ORDER BY Number
 
CREATE TABLE     #TableB
                 (
                          i INT PRIMARY KEY CLUSTERED
                 )
 
INSERT   #TableB
SELECT   Number
FROM     dbo.F_TABLE_NUMBER_RANGE(0, 999999)
ORDER BY Number
 
DELETE   f
FROM     (
                 SELECT   TOP 500000
                          i
                 FROM     #TableB
                 ORDER BY NEWID()
         ) AS f
 
-- GROUP BY
SELECT    i
FROM      (
              SELECT   0 AS s, i FROM #TableA UNION ALL
              SELECT   1, i FROM #TableB
          ) AS d
GROUP BY  i
HAVING    MAX(s) = 0
 
-- LEFT JOIN
SELECT      a.i
FROM        #TableA AS a
LEFT JOIN   #TableB AS b ON b.i = a.i
WHERE       b.i IS NULL
 
-- NOT EXISTS
SELECT   a.i
FROM     #TableA AS a
WHERE    NOT EXISTS (SELECT b.i FROM #TableB AS b WHERE b.i = a.i)
 
-- NOT IN
SELECT   a.i
FROM     #TableA AS a
WHERE    a.i NOT IN (SELECT b.i FROM #TableB AS b)

-- EXCEPT
SELECT i FROM #TableA
EXCEPT
SELECT i FROM #TableB

 
DROP TABLE    #TableA,
              #TableB


