--    

SELECT *
INTO dbo.ImportedTraceData
FROM FN_TRACE_GETTABLE(N'C:\TraceFiles\MyTrace\MyTrace.trc', 1);

--  1:      

CREATE TABLE [dbo].[ServerSideTraceData]
 (
 [TextData] [nvarchar](MAX) NULL ,
 [BinaryData] [varbinary](MAX) NULL ,
 [DatabaseID] [int] NULL ,
 [TransactionID] [bigint] NULL ,
 [LineNumber] [int] NULL ,
 [NTUserName] [nvarchar](256) NULL ,
 [NTDomainName] [nvarchar](256) NULL ,
 [HostName] [nvarchar](256) NULL ,
 [ClientProcessID] [int] NULL ,
 [ApplicationName] [nvarchar](256) NULL ,
 [LoginName] [nvarchar](256) NULL ,
 [SPID] [int] NULL ,
 [Duration] [bigint] NULL ,
 [StartTime] [datetime] NULL ,
 [EndTime] [datetime] NULL ,
 [Reads] [bigint] NULL ,
 [Writes] [bigint] NULL ,
 [CPU] [int] NULL ,
 [Permissions] [bigint] NULL ,
 [Severity] [int] NULL ,
 [EventSubClass] [int] NULL ,
 [ObjectID] [int] NULL ,
 [Success] [int] NULL ,
 [IndexID] [int] NULL ,
 [IntegerData] [int] NULL ,
 [ServerName] [nvarchar](256) NULL ,
 [EventClass] [int] NULL ,
 [ObjectType] [int] NULL ,
 [NestLevel] [int] NULL ,
 [State] [int] NULL ,
 [Error] [int] NULL ,
 [Mode] [int] NULL ,
 [Handle] [int] NULL ,
 [ObjectName] [nvarchar](256) NULL ,
 [DatabaseName] [nvarchar](256) NULL ,
 [FileName] [nvarchar](256) NULL ,
 [OwnerName] [nvarchar](256) NULL ,
 [RoleName] [nvarchar](256) NULL ,
 [TargetUserName] [nvarchar](256) NULL ,
 [DBUserName] [nvarchar](256) NULL ,
 [LoginSid] [varbinary](MAX) NULL ,
 [TargetLoginName] [nvarchar](256) NULL ,
 [TargetLoginSid] [varbinary](MAX) NULL ,
 [ColumnPermissions] [int] NULL ,
 [LinkedServerName] [nvarchar](256) NULL ,
 [ProviderName] [nvarchar](256) NULL ,
 [MethodName] [nvarchar](256) NULL ,
 [RowCounts] [bigint] NULL ,
 [RequestID] [int] NULL ,
 [XactSequence] [bigint] NULL ,
 [EventSequence] [bigint] NULL ,
 [BigintData1] [bigint] NULL ,
 [BigintData2] [bigint] NULL ,
 [GUID] [uniqueidentifier] NULL ,
 [IntegerData2] [int] NULL ,
 [ObjectID2] [bigint] NULL ,
 [Type] [int] NULL ,
 [OwnerID] [int] NULL ,
 [ParentName] [nvarchar](256) NULL ,
 [IsSystem] [int] NULL ,
 [Offset] [int] NULL ,
 [SourceDatabaseID] [int] NULL ,
 [SqlHandle] [varbinary](MAX) NULL ,
 [SessionLoginName] [nvarchar](256) NULL ,
 [PlanHandle] [varbinary](MAX) NULL ,
 [GroupID] [int] NULL
 ) ;
INSERT INTO [dbo].[ServerSideTraceData]
 SELECT *
 FROM FN_TRACE_GETTABLE(' C:\TraceFiles\MyTrace\ MyTrace.trc ',
 DEFAULT) ;

--  2:      


CREATE PROCEDURE dbo.StartBatchAndRpcCompletedTrace
AS
declare @rc int
declare @TraceID int
declare @maxfilesize bigint
set @maxfilesize = 100

declare @stoptime datetime
--   9 
set @stoptime = DATEADD(hour, 9, GETDATE())
exec @rc = sp_trace_create @TraceID output, 2, N'C:\TraceFiles\BatchAndRpcCompleted', @maxfilesize, @stoptime, 100
if (@rc != 0) goto finish

declare @on bit
set @on = 1

--     RPC
exec sp_trace_setevent @TraceID, 10, 15, @on -- EndTime
exec sp_trace_setevent @TraceID, 10, 31, @on -- Error
exec sp_trace_setevent @TraceID, 10, 8, @on -- HostName
exec sp_trace_setevent @TraceID, 10, 16, @on -- Reads
exec sp_trace_setevent @TraceID, 10, 48, @on -- RowCounts
exec sp_trace_setevent @TraceID, 10, 1, @on -- TextData
exec sp_trace_setevent @TraceID, 10, 9, @on -- ClientProcessID
exec sp_trace_setevent @TraceID, 10, 10, @on -- ApplicationName
exec sp_trace_setevent @TraceID, 10, 18, @on -- CPU
exec sp_trace_setevent @TraceID, 10, 11, @on -- LoginName
exec sp_trace_setevent @TraceID, 10, 12, @on -- SPID
exec sp_trace_setevent @TraceID, 10, 13, @on -- Duration
exec sp_trace_setevent @TraceID, 10, 14, @on -- StartTime

--     
exec sp_trace_setevent @TraceID, 12, 15, @on -- EndTime
exec sp_trace_setevent @TraceID, 12, 31, @on -- Error
exec sp_trace_setevent @TraceID, 12, 8, @on -- HostName
exec sp_trace_setevent @TraceID, 12, 16, @on -- Reads
exec sp_trace_setevent @TraceID, 12, 48, @on -- RowCounts
exec sp_trace_setevent @TraceID, 12, 1, @on -- TextData
exec sp_trace_setevent @TraceID, 12, 9, @on -- ClientProcessID
exec sp_trace_setevent @TraceID, 12, 10, @on -- ApplicationName
exec sp_trace_setevent @TraceID, 12, 18, @on -- CPU
exec sp_trace_setevent @TraceID, 12, 11, @on -- LoginName
exec sp_trace_setevent @TraceID, 12, 12, @on -- SPID
exec sp_trace_setevent @TraceID, 12, 13, @on -- Duration
exec sp_trace_setevent @TraceID, 12, 14, @on -- StartTime

--  ,   
exec @rc = sp_trace_setstatus @TraceID, 1

finish:
return @rc
go
--  3:     ,   , 
--       RPC

DECLARE
@RolloverFileNumber int = 1
,@TotalRolloverFiles int = 99 --specify actual number of rollover files
,@TraceFileName varchar(255);

--  
INSERT INTO dbo.ServerSideTraceData
SELECT *
FROM FN_TRACE_GETTABLE('C:\TraceFiles\BatchAndRpcCompleted.trc',1);
RAISERROR('%d rows imported from initial trace file', 0, 1, @@ROWCOUNT) WITH NOWAIT;

--   
WHILE @RolloverFileNumber <= @TotalRolloverFiles
BEGIN
SET @TraceFileName = 'C:\TraceFiles\BatchAndRpcCompleted_'
+ CAST(@RolloverFileNumber AS varchar(10)) + '.trc';
INSERT INTO dbo.ServerSideTraceData
SELECT *
FROM FN_TRACE_GETTABLE(@TraceFileName, 1);
RAISERROR('%d rows imported from rollover file %d', 0, 1, @@ROWCOUNT, @RolloverFileNumber) WITH NOWAIT;
SET @RolloverFileNumber = @RolloverFileNumber + 1;
END
--  4:     

--       
SELECT
HostName
,ApplicationName
,COUNT(*) AS QueryCount
,AVG(RowCounts) AS AvgRowCount
,AVG(CPU) AS AvgCPU
,SUM(CPU) AS TotalCPU
,AVG(Reads) AS AvgReads
,SUM(Reads) AS TotalReads
,AVG(Duration)/1000 AS AvgDurationMs
,SUM(Duration)/1000 AS TotalDurationMs
FROM dbo.ServerSideTraceData
WHERE
EventClass IN(10,12) --Batch and RPC completed
GROUP BY
HostName
,ApplicationName
ORDER BY
QueryCount DESC;
--  5:          

-- ,      
SELECT TOP 1000
HostName
,ApplicationName
,TextData
,RowCounts
,CPU
,Reads
,Duration/1000 DurationMs
FROM dbo.ServerSideTraceData
WHERE
EventClass IN(10,12)       RPC
AND HostName = 'WEB03'
AND ApplicationName = '.Net SqlClient Data Provider'
 AND StartTime > '20110414 10:00:00'
ORDER BY StartTime;
--  6:   ,     
